<?php

Kirki::add_section( 'header_layout', array(
    'priority'    => 1,
    'title'       => esc_html__( 'Header Layout', 'vasia' ),
    'panel'       => 'header',
) );

Kirki::add_field( 'option', [
	'type'        => 'radio-image',
	'settings'    => 'header_layout',
	'label'       => esc_html__( 'Select header layout', 'vasia' ),
	'section'     => 'header_layout',
	'default'     => '1',
	'choices'     => [
		'1'   => get_template_directory_uri() . '/assets/images/customizer/header1.jpg',
		'2' => get_template_directory_uri() . '/assets/images/customizer/header2.jpg',
		'3'  => get_template_directory_uri() . '/assets/images/customizer/header3.jpg',
		'4'  => get_template_directory_uri() . '/assets/images/customizer/header4.jpg',
		'5'  => get_template_directory_uri() . '/assets/images/customizer/header5.jpg',
		'6'  => get_template_directory_uri() . '/assets/images/customizer/header6.jpg',
		'8'  => get_template_directory_uri() . '/assets/images/customizer/header8.jpg',
		'10'  => get_template_directory_uri() . '/assets/images/customizer/header10.jpg',
		'11'  => get_template_directory_uri() . '/assets/images/customizer/header11.jpg',
		'12'  => get_template_directory_uri() . '/assets/images/customizer/header12.jpg',
		'14'  => get_template_directory_uri() . '/assets/images/customizer/header14.jpg',
		'15'  => get_template_directory_uri() . '/assets/images/customizer/header15.jpg',
		'16'  => get_template_directory_uri() . '/assets/images/customizer/header16.jpg',
	],
	'preset'      => array(
		'1'    => array(
			'settings' => array(
				'header_promo_active' => false,
				'header_topbar_active' => true,
				'header_topbar_background' => '#313030',
				'header_topbar_text_color' => '#ffffff',
				'header_main_padding' => '0',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => 'rgba(255,255,255,0)',
				'hmenu_item_align' => 'center',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#313030',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'both-inline',
			),
		),
		'2'   => array(
			'settings' => array(
				'header_promo_active' => true,
				'header_promo_color' => '#ffffff',
				'header_promo_bground' => '#313030',
				'header_promo_height' => 40,
				'header_topbar_active' => true,
				'header_topbar_background' => '#ffffff',
				'header_topbar_text_color' => '#707070',
				'header_main_padding' => '0',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => 'rgba(255,255,255,0)',
				'hmenu_item_align' => 'left',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#313030',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'both-inline',
			),
		),
		'3' => [
			'settings' => [
				'header_promo_active' => false,
				'header_topbar_active' => true,
				'header_topbar_background' => '#ffffff',
				'header_topbar_text_color' => '#707070',
				'header_main_padding' => '27',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => '#313030',
				'hmenu_item_align' => 'center',
				'hmenu_item_color' => '#ffffff',
				'hmenu_item_color_active' => '#ffffff',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'both-inline',
			],
		],
		'4'    => array(
			'settings' => array(
				'header_promo_active' => false,
				'header_topbar_active' => true,
				'header_topbar_background' => '#313030',
				'header_topbar_text_color' => '#ffffff',
				'header_main_padding' => '0',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => 'rgba(255,255,255,0)',
				'hmenu_item_align' => 'left',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#313030',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'both-inline',
			),
		),
		'5'    => array(
			'settings' => array(
				'header_promo_active' => true,
				'header_promo_color' => '#ffffff',
				'header_promo_type' => 'text',
				'header_promo_text' => '[rt_custom_block id="4051"]',
				
				'header_promo_bground' => '#c42e19',
				'header_promo_height' => 60,
				'header_topbar_active' => true,
				'header_topbar_background' => '#f6f6f6',
				'header_topbar_text_color' => '#707070',
				'header_main_padding' => '0',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => 'rgba(255,255,255,0)',
				'hmenu_item_align' => 'center',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#c42e19',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'both-inline',
			),
		),
		'6'    => array(
			'settings' => array(
				'header_promo_active' => false,
				'header_topbar_active' => true,
				'header_topbar_background' => '#313030',
				'header_topbar_text_color' => '#ffffff',
				'header_main_padding' => '27',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => '#ffffff',
				'hmenu_item_align' => 'center',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#c42e19',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'both-inline',
			),
		),
		'8'    => array(
			'settings' => array(
				'header_promo_active' => false,
				'header_topbar_active' => true,
				'header_topbar_background' => '#f6f6f6',
				'header_topbar_text_color' => '#707070',
				'header_main_padding' => '0',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => 'rgba(255,255,255,0)',
				'hmenu_item_align' => 'center',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#c42e19',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'both-inline',
			),
		),
		'10'    => array(
			'settings' => array(
				'header_promo_active' => false,
				'header_topbar_active' => false,
				'header_main_padding' => '0',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => 'rgba(255,255,255,0)',
				'hmenu_item_align' => 'center',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#313030',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'only-icon',
			),
		),
		'11'    => array(
			'settings' => array(
				'header_promo_active' => true,
				'header_promo_color' => '#ffffff',
				'header_promo_bground' => '#313030',
				'header_promo_height' => 40,
				'header_topbar_active' => false,
				'header_main_padding' => '27',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => '#ffffff',
				'hmenu_item_align' => 'center',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#313030',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'only-icon',
			),
		),
		'12'    => array(
			'settings' => array(
				'header_promo_active' => false,
				'header_topbar_active' => false,
				'header_main_padding' => '0',
				'header_main_background' => ['background-color'      => '#313030'],
				'header_main_text_color' => '#ffffff',
				'hmenu_background' => 'rgba(255,255,255,0)',
				'hmenu_item_align' => 'left',
				'hmenu_item_color' => '#ffffff',
				'hmenu_item_color_active' => '#ffffff',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'only-icon',
			),
		),
		'14'    => array(
			'settings' => array(
				'header_promo_active' => false,
				'header_topbar_active' => false,
				'header_main_padding' => '0',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => 'rgba(255,255,255,0)',
				'hmenu_item_align' => 'center',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#313030',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'only-icon',
			),
		),
		'15'    => array(
			'settings' => array(
				'header_promo_active' => true,
				'header_promo_color' => '#ffffff',
				'header_promo_bground' => '#63a2c9',
				'header_promo_height' => 40,
				'header_topbar_active' => false,
				'header_main_padding' => '0',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => 'rgba(255,255,255,0)',
				'hmenu_item_align' => 'center',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#313030',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'only-icon',
			),
		),
		'16'    => array(
			'settings' => array(
				'header_promo_active' => false,
				'header_topbar_active' => true,
				'header_topbar_background' => '#313030',
				'header_topbar_text_color' => '#ffffff',
				'header_main_padding' => '0',
				'header_main_background' => ['background-color'      => '#ffffff'],
				'header_main_text_color' => '#313030',
				'hmenu_background' => 'rgba(255,255,255,0)',
				'hmenu_item_align' => 'center',
				'hmenu_item_color' => '#313030',
				'hmenu_item_color_active' => '#313030',
				'hmenu_item_background_color' => 'rgba(255,255,255,0)',
				'hmenu_item_background_color_active' => 'rgba(255,255,255,0)',
				'hmenu_item_font' => '16',
				'hmenu_item_space' => '15',
				'he_account_design' => 'both-inline',
			),
		),
		
	),
] );